// Ys  z̐_a (for X1) t@CovO

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "d88.h"

static unsigned char dir[0x400*2];				// Directory (1024byte x 2sector)
static unsigned char buff[0x400*5*80];			// 1024byte x 5sector x 80track
char fname[FILENAME_MAX];						// ؂ot@C

D88 disk;
FILE *fp;

bool fcut(char *_fname, int _trk, int _C, int _H, int _R, int _N, int _offset, int _size)
{
	if (!disk.ReadDATA(_trk, _C, _H, _R, _N, buff, _size+_offset)) return false;
	fp = fopen(_fname,"wb");
	fwrite(buff + _offset, 1, _size, fp);
	fclose(fp);
	return true;
}

int main(int argc, char *argv[])
{
	int i,c,fn;
	int s_trk,s_sec,e_trk,e_sec,size;
	unsigned char ipl1[] = " Ys() IPL Sys ";
	unsigned char ipl2[] = "Ys()B-DISKSys ";
	unsigned char ipl3[] = "ASTEKA 2 IPL Sys ";
	unsigned char ipl4[] = "B-DISK DESUYOSys ";

	if (argc != 2)
	{
		// IvVw肪ȂƂ
		fprintf(stderr, "Usage: %s [d88file]\n",argv[0]);
		return 1;
	}

	// t@CJG[ɂȂ
	if (!disk.SetFile(argv[1]))
	{
		fprintf(stderr, "t@CI[vł܂\n");
		return 1;
	}

	int numdisk = disk.GetNumDisk();	// fBXNC[W

	for (int d=0; d<numdisk; d++)		// C[W̏
	{
		disk.SelectDisk(d);
		disk.SetRecordRange(0x01,0x10);
		disk.ReadDATA(0x00, 0x00, 0x00, 0x01, 0x01, dir, sizeof(ipl1)+1);

		if (!memcmp(&dir[1],ipl1,sizeof(ipl1)) || (!memcmp(&dir[1],ipl3,sizeof(ipl3))))
		{
			// Disk AhCo؂o (Ys/z̐_a)
			printf("Found: DISK-A  cutting ... TTLPRG\n");
			fcut("TTLPRG", 0x00, 0x00, 0x00, 0x02, 0x01, 0x0000, 0x0f00);
		}

		// fBNg̓ǂݍ
		disk.SetRecordRange(0x01,0x05);
		disk.ReadDATA(0x01, 0x00, 0x01, 0x01, 0x03, dir, 0x0800);
		for (fn=0; fn<0x80; fn++)
		{
			unsigned char *ent = &dir[fn*0x10];
			if (*ent == 0xff) break;	// fBNg̍Ō

			int i;
			int fnp = 0;
			for (i = 0x00; i < 0x06; i++)
			{
				char c = ent[i];				// t@CPo
				if (c=='\0') break;
				fname[fnp++] = c;				// t@C\
			}

			s_trk  = *(ent+0x0c);		// JngbN
			s_sec  = *(ent+0x0d);		// JnZN^
			e_trk  = *(ent+0x0e);		// IgbN
			e_sec  = *(ent+0x0f);		// IZN^
			size = ((e_trk*5+e_sec)-(s_trk*5+s_sec)+1)*0x400;	// TCYvZ

			printf("%-6s   START:%02x %02x    END:%02x %02x   SIZE:%04x\n",fname,s_trk,s_sec,e_trk,e_sec,size);
			fcut(fname, s_trk, s_trk>>1, s_trk&1, s_sec, 0x03, 0x0000, size);
		}
	}
	return 0;
}
